"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _classnames = _interopRequireDefault(require("classnames"));

var _ramda = require("ramda");

var _withComponentsContext = _interopRequireDefault(require("../hocs/withComponentsContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "reactFormBuilder": "formBuilder__reactFormBuilder___o_kxH",
  "reactFormBuilderPreview": "formBuilder__reactFormBuilderPreview___23XDF",
  "reactFormBuilderPreviewBtn": "formBuilder__reactFormBuilderPreviewBtn___5zVZr",
  "droppableContainer": "formBuilder__droppableContainer___MUGU-",
  "reactFormBuilderPreviewModal": "formBuilder__reactFormBuilderPreviewModal___3MaJN",
  "experiumPlayerBuilder": "formBuilder__experiumPlayerBuilder___gMtxw"
};

var Container =
/*#__PURE__*/
function (_Component) {
  _inherits(Container, _Component);

  function Container() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Container);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Container)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "renderItem", function (id, dragHandleProps, isDraggingOver) {
      var _this$props = _this.props,
          removeItem = _this$props.removeItem,
          editItem = _this$props.editItem,
          elements = _this$props.elements,
          placeholder = _this$props.placeholder,
          simpleView = _this$props.simpleView,
          editAllItem = _this$props.editAllItem,
          components = _this$props.components;
      var item = elements[id];
      var element = (0, _ramda.find)((0, _ramda.propEq)('type', item.type), components);
      var Component = element.component;
      return _react["default"].createElement(Component, _extends({}, item, {
        item: item,
        id: id,
        removeItem: removeItem,
        editItem: editItem,
        editAllItem: editAllItem,
        dragHandleProps: dragHandleProps,
        placeholder: placeholder,
        isDraggingOver: isDraggingOver,
        simpleView: simpleView
      }));
    });

    return _this;
  }

  _createClass(Container, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var items = this.props.items;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.reactFormBuilderPreview, 'react-form-builder-preview pull-left')
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.droppableContainer, 'droppable-container')
      }, _react["default"].createElement(_reactBeautifulDnd.Droppable, {
        droppableId: "droppable",
        type: "common"
      }, function (provided, snapshot) {
        return _react["default"].createElement("div", _extends({
          ref: provided.innerRef
        }, provided.droppableProps), items.map(function (id, index) {
          return _react["default"].createElement(_reactBeautifulDnd.Draggable, {
            key: id,
            draggableId: id,
            index: index
          }, function (provided) {
            return _react["default"].createElement("div", _extends({
              ref: provided.innerRef
            }, provided.draggableProps), _this2.renderItem(id, provided.dragHandleProps, snapshot.isDraggingOver));
          });
        }), provided.placeholder);
      })));
    }
  }]);

  return Container;
}(_react.Component);

_defineProperty(Container, "propTypes", {
  items: _propTypes["default"].array,
  reorderItems: _propTypes["default"].func,
  editItem: _propTypes["default"].func,
  removeItem: _propTypes["default"].func,
  elements: _propTypes["default"].object,
  placeholder: _propTypes["default"].string
});

var _default = (0, _withComponentsContext["default"])(Container);

exports["default"] = _default;