"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormBuilder = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _ramda = require("ramda");

var _classnames = _interopRequireDefault(require("classnames"));

var _Toolbar = _interopRequireDefault(require("./Toolbar"));

var _Container = _interopRequireDefault(require("./Container"));

var _withData = _interopRequireDefault(require("../hocs/withData"));

var _FormGenerator = require("./FormGenerator");

var _dnd = require("../utils/dnd");

var _Settings = _interopRequireDefault(require("./Settings"));

var _FileUrlContext = _interopRequireDefault(require("../contexts/FileUrlContext"));

var _MceLanguageUrl = _interopRequireDefault(require("../contexts/MceLanguageUrl"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "reactFormBuilder": "formBuilder__reactFormBuilder___o_kxH",
  "reactFormBuilderPreview": "formBuilder__reactFormBuilderPreview___23XDF",
  "reactFormBuilderPreviewBtn": "formBuilder__reactFormBuilderPreviewBtn___5zVZr",
  "droppableContainer": "formBuilder__droppableContainer___MUGU-",
  "reactFormBuilderPreviewModal": "formBuilder__reactFormBuilderPreviewModal___3MaJN",
  "experiumPlayerBuilder": "formBuilder__experiumPlayerBuilder___gMtxw"
};

var FormBuilderComponent =
/*#__PURE__*/
function (_Component) {
  _inherits(FormBuilderComponent, _Component);

  function FormBuilderComponent() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FormBuilderComponent);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FormBuilderComponent)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      preview: false,
      showSettings: false
    });

    _defineProperty(_assertThisInitialized(_this), "openPreview", function () {
      var onPreviewOpen = _this.props.onPreviewOpen;

      _this.setState({
        preview: true
      });

      onPreviewOpen && onPreviewOpen();
    });

    _defineProperty(_assertThisInitialized(_this), "closePreview", function () {
      var onPreviewClose = _this.props.onPreviewClose;

      _this.setState({
        preview: false
      });

      onPreviewClose && onPreviewClose();
    });

    _defineProperty(_assertThisInitialized(_this), "onDragEnd", function (result) {
      if (!result.destination) {
        return;
      }

      if ((0, _ramda.contains)('field', result.type)) {
        var id = result.destination.droppableId;

        _this.props.editItem(id, 'options', (0, _dnd.reorder)(_this.props.elements[id].options, result.source.index, result.destination.index));

        return;
      }

      if (result.source.droppableId === 'toolbar') {
        _this.props.addItem(result.draggableId, result.destination.index);
      } else {
        _this.props.reorderItems(result.source.index, result.destination.index);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "openSettings", function () {
      return _this.setState({
        showSettings: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "closeSettings", function () {
      return _this.setState({
        showSettings: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "editCommonSettings", function (settings) {
      _this.props.editCommonSettings(settings);

      _this.closeSettings();
    });

    return _this;
  }

  _createClass(FormBuilderComponent, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          items = _this$props.items,
          elements = _this$props.elements,
          addItem = _this$props.addItem,
          components = _this$props.components,
          commonSettings = _this$props.commonSettings,
          uploadUrl = _this$props.uploadUrl,
          downloadUrl = _this$props.downloadUrl,
          mceLanguageUrl = _this$props.mceLanguageUrl;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.experiumPlayerBuilder, 'experium-player-builder')
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.reactFormBuilder, 'react-form-builder clearfix')
      }, _react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.reactFormBuilderPreviewBtn, 'react-form-builder-preview-btn')
      }, _react["default"].createElement(_antd.Button.Group, null, _react["default"].createElement(_antd.Button, {
        type: "primary",
        onClick: this.openPreview,
        icon: "eye"
      }, "\u041F\u0440\u0435\u0434\u043F\u0440\u043E\u0441\u043C\u043E\u0442\u0440"), _react["default"].createElement(_antd.Button, {
        icon: "setting",
        onClick: this.openSettings
      }, "\u041D\u0430\u0441\u0442\u0440\u043E\u0439\u043A\u0438"))), _react["default"].createElement(_FileUrlContext["default"].Provider, {
        value: {
          uploadUrl: uploadUrl,
          downloadUrl: downloadUrl
        }
      }, _react["default"].createElement(_MceLanguageUrl["default"].Provider, {
        value: mceLanguageUrl
      }, _react["default"].createElement(_reactBeautifulDnd.DragDropContext, {
        onDragEnd: this.onDragEnd
      }, _react["default"].createElement(_Container["default"], this.props), _react["default"].createElement(_Toolbar["default"], {
        addItem: addItem
      })))), _react["default"].createElement(_antd.Modal, {
        className: (0, _classnames["default"])(styles.reactFormBuilderPreviewModal, 'react-form-builder-preview-modal'),
        title: "\u041F\u0440\u0435\u0434\u043F\u0440\u043E\u0441\u043C\u043E\u0442\u0440",
        visible: this.state.preview,
        onCancel: this.closePreview,
        destroyOnClose: true,
        width: "100%",
        style: {
          maxWidth: 1000
        },
        footer: null
      }, _react["default"].createElement(_FormGenerator.FormGenerator, {
        data: {
          items: items,
          elements: elements,
          common: commonSettings
        },
        components: components,
        uploadUrl: uploadUrl,
        downloadUrl: downloadUrl,
        preview: true
      })), _react["default"].createElement(_antd.Modal, {
        title: "\u041D\u0430\u0441\u0442\u0440\u043E\u0439\u043A\u0438",
        className: "react-form-builder-settings-modal",
        visible: this.state.showSettings,
        onCancel: this.closeSettings,
        destroyOnClose: true,
        footer: null
      }, _react["default"].createElement(_Settings["default"], {
        settings: commonSettings,
        onSubmit: this.editCommonSettings
      }))));
    }
  }]);

  return FormBuilderComponent;
}(_react.Component);

_defineProperty(FormBuilderComponent, "propTypes", {
  addItem: _propTypes["default"].func,
  reorderItems: _propTypes["default"].func,
  items: _propTypes["default"].array,
  elements: _propTypes["default"].object,
  onPreviewOpen: _propTypes["default"].func,
  onPreviewClose: _propTypes["default"].func,
  placeholder: _propTypes["default"].string
});

var FormBuilder = (0, _withData["default"])(FormBuilderComponent);
exports.FormBuilder = FormBuilder;