"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormGenerator = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

var _ramda = require("ramda");

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _classnames = _interopRequireDefault(require("classnames"));

var _reactFinalForm = require("react-final-form");

var _componentsDefaults = _interopRequireDefault(require("../constants/componentsDefaults"));

var _FormField = _interopRequireDefault(require("./FormField"));

var _FileUrlContext = _interopRequireDefault(require("../contexts/FileUrlContext"));

var _ComponentsContext = _interopRequireDefault(require("../contexts/ComponentsContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "reactFormBuilder": "formBuilder__reactFormBuilder___o_kxH",
  "reactFormBuilderPreview": "formBuilder__reactFormBuilderPreview___23XDF",
  "reactFormBuilderPreviewBtn": "formBuilder__reactFormBuilderPreviewBtn___5zVZr",
  "droppableContainer": "formBuilder__droppableContainer___MUGU-",
  "reactFormBuilderPreviewModal": "formBuilder__reactFormBuilderPreviewModal___3MaJN",
  "experiumPlayerBuilder": "formBuilder__experiumPlayerBuilder___gMtxw"
};

var FormGenerator =
/*#__PURE__*/
function (_Component) {
  _inherits(FormGenerator, _Component);

  function FormGenerator() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FormGenerator);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FormGenerator)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      page: 0
    });

    _defineProperty(_assertThisInitialized(_this), "onSubmit", function (values) {
      _this.props.onSubmit && _this.props.onSubmit(values);
    });

    _defineProperty(_assertThisInitialized(_this), "getComponents", function (placeholder) {
      return (0, _ramda.concat)((0, _componentsDefaults["default"])(placeholder), _this.props.components);
    });

    _defineProperty(_assertThisInitialized(_this), "goBack", function () {
      return _this.setState(function (prev) {
        return {
          page: prev.page - 1
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "goNext", function () {
      return _this.setState(function (prev) {
        return {
          page: prev.page + 1
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderFooter", function (staticContent, index, invalid) {
      var _this$props$data = _this.props.data,
          _this$props$data$comm = _this$props$data.common,
          common = _this$props$data$comm === void 0 ? {} : _this$props$data$comm,
          items = _this$props$data.items;
      var page = _this.state.page;
      return _react["default"].createElement(_antd.Button.Group, null, common.pages && page > 0 && _react["default"].createElement(_antd.Button, {
        htmlType: "submit",
        onClick: !invalid ? _this.goBack : null
      }, "\u041D\u0430\u0437\u0430\u0434"), (!staticContent && common.everyQuestionSubmit || (common.pages ? page : index) === items.length - 1) && _react["default"].createElement(_antd.Button, {
        htmlType: "submit",
        type: "primary"
      }, "\u0421\u043E\u0445\u0440\u0430\u043D\u0438\u0442\u044C"), common.pages && page < items.length - 1 && _react["default"].createElement(_antd.Button, {
        htmlType: "submit",
        onClick: !invalid ? _this.goNext : null
      }, "\u0412\u043F\u0435\u0440\u0435\u0434"));
    });

    _defineProperty(_assertThisInitialized(_this), "renderRow", function (id, index, invalid) {
      var _this$props = _this.props,
          _this$props$data2 = _this$props.data,
          _this$props$data2$ele = _this$props$data2.elements,
          elements = _this$props$data2$ele === void 0 ? {} : _this$props$data2$ele,
          _this$props$data2$com = _this$props$data2.common,
          common = _this$props$data2$com === void 0 ? {} : _this$props$data2$com,
          items = _this$props$data2.items,
          preview = _this$props.preview,
          values = _this$props.values,
          view = _this$props.view,
          placeholder = _this$props.placeholder;
      var item = elements[id];

      var _find = (0, _ramda.find)((0, _ramda.propEq)('type', item.type), _this.getComponents(placeholder)),
          staticContent = _find.staticContent,
          fieldType = _find.fieldType,
          Component = _find.formComponent;

      return _react["default"].createElement(_antd.Row, {
        key: "row-".concat(id)
      }, _react["default"].createElement(_antd.Col, null, staticContent ? _react["default"].createElement(Component, _extends({}, item, {
        id: id
      })) : _react["default"].createElement(_FormField["default"], {
        id: id,
        item: item,
        fieldType: fieldType,
        component: Component,
        value: values[id],
        preview: preview,
        view: view,
        isField: true
      })), _this.renderFooter(staticContent, index, invalid));
    });

    _defineProperty(_assertThisInitialized(_this), "hasFields", function () {
      var _this$props$data$elem = _this.props.data.elements,
          elements = _this$props$data$elem === void 0 ? {} : _this$props$data$elem;
      return (0, _ramda.any)(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            item = _ref2[1];

        return !(0, _ramda.find)((0, _ramda.propEq)('type', item.type), _this.getComponents(placeholder)).staticContent;
      }, (0, _ramda.toPairs)(elements));
    });

    return _this;
  }

  _createClass(FormGenerator, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          _this$props2$data = _this$props2.data,
          _this$props2$data$ite = _this$props2$data.items,
          items = _this$props2$data$ite === void 0 ? [] : _this$props2$data$ite,
          _this$props2$data$com = _this$props2$data.common,
          common = _this$props2$data$com === void 0 ? {} : _this$props2$data$com,
          uploadUrl = _this$props2.uploadUrl,
          downloadUrl = _this$props2.downloadUrl,
          values = _this$props2.values;
      var page = this.state.page;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.experiumPlayerBuilder, 'experium-player-builder'),
        style: {
          background: common.pageColor || 'transparent',
          padding: 15
        }
      }, _react["default"].createElement(_ComponentsContext["default"].Provider, {
        value: this.getComponents()
      }, _react["default"].createElement(_FileUrlContext["default"].Provider, {
        value: {
          uploadUrl: uploadUrl,
          downloadUrl: downloadUrl
        }
      }, _react["default"].createElement(_reactFinalForm.Form, {
        className: "formGenerator",
        onSubmit: this.onSubmit,
        initialValues: values,
        subscription: {
          submitting: true,
          submitFailed: true,
          invalid: true
        },
        render: function render(_ref3) {
          var handleSubmit = _ref3.handleSubmit,
              invalid = _ref3.invalid;
          return _react["default"].createElement(_antd.Form, {
            onSubmit: handleSubmit
          }, _react["default"].createElement(_reactBeautifulDnd.DragDropContext, null, (0, _ramda.addIndex)(_ramda.filter)(function (item, index) {
            return common.pages ? index === page : true;
          }, items).map(function (row, index) {
            return _this2.renderRow(row, index, invalid);
          })));
        }
      }))));
    }
  }]);

  return FormGenerator;
}(_react.Component);

exports.FormGenerator = FormGenerator;

_defineProperty(FormGenerator, "propTypes", {
  data: _propTypes["default"].object,
  onSubmit: _propTypes["default"].func,
  preview: _propTypes["default"].bool,
  values: _propTypes["default"].object,
  view: _propTypes["default"].bool
});

_defineProperty(FormGenerator, "defaultProps", {
  data: {},
  values: {},
  components: []
});