"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _classnames = _interopRequireDefault(require("classnames"));

var _ComponentsContext = _interopRequireDefault(require("../contexts/ComponentsContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "draggableToolbarItemWrapper": "toolbar__draggableToolbarItemWrapper___1Us4d",
  "draggingToolbarItemWrapper": "toolbar__draggingToolbarItemWrapper___1BVC1",
  "draggableToolbarItem": "toolbar__draggableToolbarItem___Sj7FY",
  "toolbar": "toolbar__toolbar___1Qa5r"
};

var Toolbar =
/*#__PURE__*/
function (_Component) {
  _inherits(Toolbar, _Component);

  function Toolbar() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Toolbar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Toolbar)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "renderToolbarList", function (items) {
      return items.map(function (item, index) {
        return _react["default"].createElement(_reactBeautifulDnd.Draggable, {
          key: item.type,
          draggableId: item.type,
          index: index
        }, function (provided, snapshot) {
          return _react["default"].createElement(_react.Fragment, null, _react["default"].createElement("li", _extends({
            className: (0, _classnames["default"])(styles.draggableToolbarItemWrapper, 'draggable-toolbar-item-wrapper', _defineProperty({}, styles.draggingToolbarItemWrapper, !snapshot.isDragging)),
            ref: provided.innerRef
          }, provided.draggableProps, provided.dragHandleProps), _react["default"].createElement("div", {
            className: (0, _classnames["default"])(styles.draggableToolbarItem, 'draggable-toolbar-item'),
            onClick: function onClick() {
              return _this.props.addItem(item.type);
            }
          }, _react["default"].createElement("i", {
            className: "fa fa-".concat(item.icon)
          }), item.name)), snapshot.isDragging && _react["default"].createElement("div", {
            className: (0, _classnames["default"])(styles.draggableToolbarItemWrapper, 'draggable-toolbar-item-wrapper')
          }, _react["default"].createElement("div", {
            className: (0, _classnames["default"])(styles.draggableToolbarItem, 'draggable-toolbar-item')
          }, _react["default"].createElement("i", {
            className: "fa fa-".concat(item.icon)
          }), " ", item.name)));
        });
      });
    });

    return _this;
  }

  _createClass(Toolbar, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.toolbar, 'toolbar')
      }, _react["default"].createElement("h4", null, "\u041F\u0430\u043D\u0435\u043B\u044C \u044D\u043B\u0435\u043C\u0435\u043D\u0442\u043E\u0432"), _react["default"].createElement(_reactBeautifulDnd.Droppable, {
        droppableId: "toolbar",
        isDropDisabled: true,
        type: "common"
      }, function (provided) {
        return _react["default"].createElement("ul", {
          ref: provided.innerRef
        }, _react["default"].createElement(_ComponentsContext["default"].Consumer, null, _this2.renderToolbarList), _react["default"].createElement("div", {
          style: {
            display: 'none'
          }
        }, provided.placeholder));
      }));
    }
  }]);

  return Toolbar;
}(_react.Component);

exports["default"] = Toolbar;

_defineProperty(Toolbar, "propTypes", {
  items: _propTypes["default"].array
});