"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _tinymceReact = require("@tinymce/tinymce-react");

var _classnames = _interopRequireDefault(require("classnames"));

var _withFieldWrapper = _interopRequireDefault(require("../../hocs/withFieldWrapper"));

var _MceLanguageUrl = _interopRequireDefault(require("../../contexts/MceLanguageUrl"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var styles = {
  "editorInput": "editorInput__editorInput___1WcYS",
  "editorInputShort": "editorInput__editorInputShort___3k_dC"
};

var MceEditor =
/*#__PURE__*/
function (_Component) {
  _inherits(MceEditor, _Component);

  function MceEditor() {
    _classCallCheck(this, MceEditor);

    return _possibleConstructorReturn(this, _getPrototypeOf(MceEditor).apply(this, arguments));
  }

  _createClass(MceEditor, [{
    key: "render",
    value: function render() {
      var _cx;

      var _this$props = this.props,
          value = _this$props.input.value,
          onChange = _this$props.onChange,
          _short = _this$props["short"],
          hidePreview = _this$props.hidePreview;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])((_cx = {}, _defineProperty(_cx, styles.editorInputShort, _short), _defineProperty(_cx, styles.editorInput, !hidePreview), _cx))
      }, _react["default"].createElement(_MceLanguageUrl["default"].Consumer, null, function (languageUrl) {
        return _react["default"].createElement(_tinymceReact.Editor, {
          value: value,
          onEditorChange: onChange,
          inline: !hidePreview,
          init: {
            plugins: 'image lists link table',
            menubar: false,
            language: 'ru',
            branding: false,
            content_style: hidePreview ? "\n                                div { color: rgba(0, 0, 0, 0.65); font-size: 14px; color: rgba(0, 0, 0, 0.65); font-size: 14px; font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', 'PingFang SC', 'Hiragino Sans GB', 'Microsoft YaHei', 'Helvetica Neue', Helvetica, Arial, sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol' }\n                                h1 { font-size: 28px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); }\n                                h2 { font-size: 21px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); }\n                                h3 { font-size: 16.38px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); }\n                                h4 { font-size: 14px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); }\n                                h5 { font-size: 11.62px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); }\n                                h6 { font-size: 9.38px; font-weight: 500; margin-bottom: 0.5em; color: rgba(0, 0, 0, 0.85); }\n                                p { margin-top: 0; margin-bottom: 1em; color: rgba(0, 0, 0, 0.65); font-size: 14px; }\n                                ol, li, ul, span { color: rgba(0, 0, 0, 0.65); font-size: 14px; }\n                            " : null,
            language_url: languageUrl || '/translations/ru.js',
            toolbar_drawer: 'sliding',
            toolbar: _short ? 'undo redo | bold italic underline | forecolor backcolor | link | removeformat' : 'undo redo | formatselect | fontselect fontsizeselect | bold italic underline |  alignleft aligncenter alignright alignjustify | forecolor backcolor | bullist numlist | image | link | table tabledelete | tableprops tablerowprops tablecellprops | tableinsertrowbefore tableinsertrowafter tabledeleterow | tableinsertcolbefore tableinsertcolafter tabledeletecol | removeformat',
            images_upload_handler: function images_upload_handler(info, success) {
              var fr = new FileReader();
              fr.readAsDataURL(info.blob());

              fr.onload = function () {
                return success(fr.result);
              };
            }
          }
        });
      }));
    }
  }]);

  return MceEditor;
}(_react.Component);

var _default = (0, _withFieldWrapper["default"])(MceEditor);

exports["default"] = _default;