"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _reactFinalForm = require("react-final-form");

var _uniqid = _interopRequireDefault(require("uniqid"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _classnames = _interopRequireDefault(require("classnames"));

var _ImageUploader = _interopRequireDefault(require("./ImageUploader"));

var _MceEditor = _interopRequireDefault(require("./MceEditor"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "item": "multipleField__item___1fVdw",
  "itemHasImage": "multipleField__itemHasImage___35LM3",
  "itemContent": "multipleField__itemContent___2EMMX",
  "dragHandler": "multipleField__dragHandler___1GPvk"
};

var Multiple =
/*#__PURE__*/
function (_Component) {
  _inherits(Multiple, _Component);

  function Multiple() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Multiple);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Multiple)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "addItem", function () {
      var _this$props = _this.props,
          fields = _this$props.fields,
          variantPlaceholder = _this$props.variantPlaceholder;
      fields.push({
        label: "".concat(variantPlaceholder, " ").concat(fields.length),
        id: (0, _uniqid["default"])('radio_option_')
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onDragEnd", function (result) {
      if (!result.destination) {
        return;
      }

      _this.props.fields.move(result.source.index, result.destination.index);
    });

    return _this;
  }

  _createClass(Multiple, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          label = _this$props2.label,
          fields = _this$props2.fields;
      return _react["default"].createElement(_antd.Form.Item, {
        label: label
      }, _react["default"].createElement(_reactBeautifulDnd.DragDropContext, {
        onDragEnd: this.onDragEnd
      }, _react["default"].createElement(_reactBeautifulDnd.Droppable, {
        droppableId: "multiple"
      }, function (provided) {
        return _react["default"].createElement("div", _extends({}, provided.droppableProps, {
          ref: provided.innerRef
        }), fields.map(function (name, index) {
          return _react["default"].createElement(_reactBeautifulDnd.Draggable, {
            key: fields.value[index].id,
            draggableId: fields.value[index].id,
            index: index
          }, function (dragProvided) {
            return _react["default"].createElement("div", _extends({
              ref: dragProvided.innerRef
            }, dragProvided.draggableProps), _react["default"].createElement("div", {
              className: (0, _classnames["default"])(styles.item, 'multiple-field-item', _defineProperty({}, styles.itemHasImage, !!fields.value[index].image))
            }, _react["default"].createElement("div", _extends({
              className: (0, _classnames["default"])(styles.dragHandler, 'multiple-field-drag-handler')
            }, dragProvided.dragHandleProps), _react["default"].createElement("i", {
              className: "fa fa-reorder"
            })), _react["default"].createElement("div", {
              className: (0, _classnames["default"])(styles.itemContent, 'multiple-field-item-content')
            }, _react["default"].createElement(_reactFinalForm.Field, {
              name: "".concat(name, ".label"),
              component: _MceEditor["default"],
              "short": true
            }), _react["default"].createElement(_reactFinalForm.Field, {
              name: "".concat(name, ".image"),
              component: _ImageUploader["default"]
            }), fields.length > 1 && _react["default"].createElement(_antd.Button, {
              ghost: true,
              type: "danger",
              icon: "delete",
              onClick: function onClick() {
                return fields.remove(index);
              }
            }))));
          });
        }), provided.placeholder);
      })), _react["default"].createElement(_antd.Button, {
        icon: "plus",
        onClick: this.addItem
      }, "\u0414\u043E\u0431\u0430\u0432\u0438\u0442\u044C"));
    }
  }]);

  return Multiple;
}(_react.Component);

exports["default"] = Multiple;