"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _withFieldWrapper = _interopRequireDefault(require("../../hocs/withFieldWrapper"));

var _withFileUrlContext = _interopRequireDefault(require("../../hocs/withFileUrlContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Uploader =
/*#__PURE__*/
function (_Component) {
  _inherits(Uploader, _Component);

  function Uploader() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Uploader);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Uploader)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      error: false,
      uploading: false
    });

    _defineProperty(_assertThisInitialized(_this), "reader", new FileReader());

    _defineProperty(_assertThisInitialized(_this), "beforeUpload", function (file) {
      _this.reader.readAsDataURL(file);

      _this.reader.onload = function () {
        return _this.props.onChange({
          body: _this.reader.result,
          name: file.name
        });
      };

      return false;
    });

    _defineProperty(_assertThisInitialized(_this), "onChange", function (info) {
      var _info$file = info.file,
          status = _info$file.status,
          response = _info$file.response,
          name = _info$file.name;

      switch (status) {
        case 'uploading':
          _this.setState({
            uploading: true
          });

          break;

        case 'done':
          _this.props.onChange({
            id: response.id,
            name: name
          });

          _this.state.error && _this.setState({
            error: false,
            uploading: false
          });
          break;

        case 'error':
          _this.setState({
            error: true,
            uploading: false
          });

          break;

        default:
          return;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "delete", function () {
      return _this.props.onChange(null);
    });

    return _this;
  }

  _createClass(Uploader, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          value = _this$props.input.value,
          uploadUrl = _this$props.uploadUrl,
          accept = _this$props.accept,
          withoutUrl = _this$props.withoutUrl;
      var props = uploadUrl && !withoutUrl ? {
        action: uploadUrl,
        onChange: this.onChange
      } : {
        beforeUpload: this.beforeUpload
      };
      return value ? _react["default"].createElement(_react.Fragment, null, _react["default"].createElement("span", {
        style: {
          marginRight: 15
        }
      }, value.name), _react["default"].createElement(_antd.Button, {
        type: "danger",
        onClick: this["delete"]
      }, _react["default"].createElement(_antd.Icon, {
        type: "delete"
      }), " \u0423\u0434\u0430\u043B\u0438\u0442\u044C")) : _react["default"].createElement(_react.Fragment, null, _react["default"].createElement(_antd.Upload, _extends({}, props, {
        accept: accept,
        showUploadList: false,
        disabled: this.state.uploading
      }), _react["default"].createElement(_antd.Button, {
        loading: this.state.uploading,
        icon: "upload"
      }, "\u0417\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044C \u0444\u0430\u0439\u043B")), this.state.error && _react["default"].createElement("div", {
        style: {
          color: 'red'
        }
      }, "\u041D\u0435 \u0443\u0434\u0430\u043B\u043E\u0441\u044C \u0437\u0430\u0433\u0440\u0443\u0437\u0438\u0442\u044C \u0444\u0430\u0439\u043B"));
    }
  }]);

  return Uploader;
}(_react.Component);

var _default = (0, _withFieldWrapper["default"])((0, _withFileUrlContext["default"])(Uploader));

exports["default"] = _default;