"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _draftJs = require("draft-js");

var _reactOnclickoutside = _interopRequireDefault(require("react-onclickoutside"));

var _classnames = _interopRequireDefault(require("classnames"));

var _editor = require("../../utils/editor");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "toolbar": "editorToolbar__toolbar___r4vlg",
  "showToolbar": "editorToolbar__showToolbar___2Ygda",
  "toolbarItems": "editorToolbar__toolbarItems___2zvDc",
  "toolbarItem": "editorToolbar__toolbarItem___1D-K3",
  "toolbarItemsArrow": "editorToolbar__toolbarItemsArrow___2PwFu",
  "active": "editorToolbar__active___24dHq",
  "bold": "editorToolbar__bold___1I-VY",
  "italic": "editorToolbar__italic___1cQ9v",
  "underline": "editorToolbar__underline___xoLQR",
  "toolbarLinkContainer": "editorToolbar__toolbarLinkContainer___14xpk"
};

var LinkInput =
/*#__PURE__*/
function (_Component) {
  _inherits(LinkInput, _Component);

  function LinkInput(props) {
    var _this;

    _classCallCheck(this, LinkInput);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LinkInput).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "handleClickOutside", function () {
      return _this.props.toggleLinkToolbar(false);
    });

    _defineProperty(_assertThisInitialized(_this), "applyValue", function () {
      var href = _this.state.href;

      var _getEditorData = (0, _editor.getEditorData)(_this.editorStateBackup),
          contentState = _getEditorData.contentState;

      if (_this.entity === null) {
        _this.editorStateBackup = (0, _editor.createEntity)(_this.editorStateBackup, 'LINK', {
          href: href
        });
      } else {
        contentState.mergeEntityData(_this.entity.entityKey, {
          href: href
        });
      }

      _this.props.toggleLinkToolbar(false);
    });

    _defineProperty(_assertThisInitialized(_this), "remove", function () {
      _this.editorStateBackup = (0, _editor.removeEntity)(_this.editorStateBackup, 'LINK');

      _this.props.toggleLinkToolbar(false);
    });

    _this.entity = (0, _editor.findEntityInSelection)(props.editorState, 'LINK');
    _this.state = {
      href: _this.entity !== null ? _this.entity.entity.data.href : ''
    };
    return _this;
  }

  _createClass(LinkInput, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _this$props = this.props,
          editorState = _this$props.editorState,
          onChange = _this$props.onChange;

      if (this.entity !== null) {
        this.editorStateBackup = (0, _editor.extendSelectionByData)(editorState, (0, _editor.getEntities)(editorState, 'LINK', this.entity.entityKey));
      } else {
        this.editorStateBackup = editorState;
      }

      onChange(_draftJs.RichUtils.toggleInlineStyle(this.editorStateBackup, 'SELECTED'));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.props.onChange(this.editorStateBackup);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react["default"].createElement("li", {
        className: (0, _classnames["default"])(styles.toolbarLinkContainer, 'toolbar-link-container')
      }, _react["default"].createElement("input", {
        type: "text",
        placeholder: "http://example.com",
        value: this.state.href,
        onChange: function onChange(e) {
          return _this2.setState({
            href: e.target.value
          });
        }
      }), _react["default"].createElement("button", {
        onClick: this.applyValue
      }, _react["default"].createElement("i", {
        className: "fa fa-check-circle"
      })), this.entity !== null && _react["default"].createElement("button", {
        onClick: this.remove
      }, _react["default"].createElement("i", {
        className: "fa fa-times-circle"
      })));
    }
  }]);

  return LinkInput;
}(_react.Component);

var _default = (0, _reactOnclickoutside["default"])(LinkInput);

exports["default"] = _default;