"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RangeField = exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

var _classnames = _interopRequireDefault(require("classnames"));

var _withElementWrapper = require("../../hocs/withElementWrapper");

var _Editor = _interopRequireDefault(require("./Editor"));

var _withFieldWrapper = _interopRequireDefault(require("../../hocs/withFieldWrapper"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "rangeSettings": "range__rangeSettings___2Or0X",
  "maxValueInput": "range__maxValueInput___K7Cw9",
  "minValueInput": "range__minValueInput___2xpVD",
  "stepInput": "range__stepInput___3QSRm"
};

var Range =
/*#__PURE__*/
function (_Component) {
  _inherits(Range, _Component);

  function Range() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Range);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Range)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "onChange", function (value) {
      var onChange = _this.props.onChange;
      onChange && onChange(value);
    });

    return _this;
  }

  _createClass(Range, [{
    key: "render",
    value: function render() {
      var _ref;

      var _this$props = this.props,
          step = _this$props.step,
          minValue = _this$props.minValue,
          maxValue = _this$props.maxValue,
          minLabel = _this$props.minLabel,
          maxLabel = _this$props.maxLabel,
          disabled = _this$props.disabled,
          value = _this$props.input.value,
          isEditor = _this$props.isEditor,
          _onChange = _this$props.onChange;
      return _react["default"].createElement("div", null, _react["default"].createElement(_antd.Slider, {
        min: minValue,
        max: maxValue,
        value: value || minValue,
        step: step,
        marks: (_ref = {}, _defineProperty(_ref, minValue, {
          label: isEditor ? _react["default"].createElement(_Editor["default"], _extends({}, this.props, {
            path: "minLabel",
            "short": true
          })) : minLabel
        }), _defineProperty(_ref, maxValue, {
          label: isEditor ? _react["default"].createElement(_Editor["default"], _extends({}, this.props, {
            path: "maxLabel",
            "short": true
          })) : maxLabel
        }), _ref),
        disabled: disabled,
        onChange: this.onChange
      }), isEditor && _react["default"].createElement("div", {
        className: (0, _classnames["default"])(styles.rangeSettings, 'range-settings')
      }, _react["default"].createElement(_antd.InputNumber, {
        className: (0, _classnames["default"])(styles.minValueInput, 'min-value-input'),
        value: minValue,
        onChange: function onChange(v) {
          return _onChange('minValue', v);
        }
      }), _react["default"].createElement("span", {
        className: (0, _classnames["default"])(styles.stepInput, 'step-input')
      }, "\u0428\u0430\u0433: ", _react["default"].createElement(_antd.InputNumber, {
        value: step,
        onChange: function onChange(v) {
          return _onChange('step', v);
        }
      })), _react["default"].createElement(_antd.InputNumber, {
        className: (0, _classnames["default"])(styles.maxValueInput, 'max-value-input'),
        value: maxValue,
        onChange: function onChange(v) {
          return _onChange('maxValue', v);
        }
      })));
    }
  }]);

  return Range;
}(_react.Component);

_defineProperty(Range, "propTypes", {
  step: _propTypes["default"].number,
  minValue: _propTypes["default"].number,
  maxValue: _propTypes["default"].number,
  fieldName: _propTypes["default"].string,
  minLabel: _propTypes["default"].PropTypes.oneOfType([_propTypes["default"].string, _propTypes["default"].element]),
  maxLabel: _propTypes["default"].PropTypes.oneOfType([_propTypes["default"].string, _propTypes["default"].element])
});

_defineProperty(Range, "defaultProps", {
  input: {}
});

var _default = (0, _withElementWrapper.withElementWrapper)(Range);

exports["default"] = _default;
var RangeField = (0, _withFieldWrapper["default"])(Range);
exports.RangeField = RangeField;