"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withElementWrapper = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _antd = require("antd");

var _ramda = require("ramda");

var _classnames = _interopRequireDefault(require("classnames"));

var _EditElement = _interopRequireDefault(require("../components/EditElement"));

var _EditModalContext = _interopRequireDefault(require("../contexts/EditModalContext"));

var _withComponentsContext = _interopRequireDefault(require("./withComponentsContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = {
  "sortableRowWrapper": "sortableRow__sortableRowWrapper___1L9Qx",
  "sortableRow": "sortableRow__sortableRow___1Pn_L",
  "sortableRowContent": "sortableRow__sortableRowContent___12EAS",
  "sortableRowDragHandle": "sortableRow__sortableRowDragHandle___HBS35",
  "toolbarRemoveBtn": "sortableRow__toolbarRemoveBtn___QAYsb",
  "toolbarEditBtn": "sortableRow__toolbarEditBtn___2hxSs",
  "sortableRowInfo": "sortableRow__sortableRowInfo___w8I0I",
  "sortableRowContentInfo": "sortableRow__sortableRowContentInfo___LXp6p"
};
var editorStyles = {
  "editor": "editor__editor___1oMVM",
  "editorCol": "editor__editorCol___1rlEk",
  "editorPreviewCol": "editor__editorPreviewCol___3Lgw0",
  "editorField": "editor__editorField___1_Zq6",
  "editorModal": "editor__editorModal___2hd0A",
  "editorFooter": "editor__editorFooter___3Mszd",
  "editorFields": "editor__editorFields___csq02",
  "editorColHidePreview": "editor__editorColHidePreview___8DImo"
};

var withElementWrapper = function withElementWrapper(WrappedComponent) {
  var ElementWrapper =
  /*#__PURE__*/
  function (_Component) {
    _inherits(ElementWrapper, _Component);

    function ElementWrapper() {
      var _getPrototypeOf2;

      var _this;

      _classCallCheck(this, ElementWrapper);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ElementWrapper)).call.apply(_getPrototypeOf2, [this].concat(args)));

      _defineProperty(_assertThisInitialized(_this), "renderComponent", function (staticContent, ableCorrect) {
        var _this$props = _this.props,
            editItem = _this$props.editItem,
            id = _this$props.id;
        return _react["default"].createElement(WrappedComponent, _extends({}, _this.props, {
          onChange: function onChange(prop, content) {
            return editItem(id, prop, content);
          },
          isEditor: true,
          disabled: !ableCorrect,
          staticContent: staticContent
        }));
      });

      _defineProperty(_assertThisInitialized(_this), "renderLabel", function () {
        var _this$props2 = _this.props,
            id = _this$props2.id,
            editItem = _this$props2.editItem;

        var EditorComponent = require('../components/formElements/EditorComponent');

        return _react["default"].createElement(EditorComponent, _extends({}, _this.props, {
          path: "label",
          "short": true,
          onChange: function onChange(prop, content) {
            return editItem(id, prop, content);
          },
          isEditor: true
        }));
      });

      _defineProperty(_assertThisInitialized(_this), "onSubmit", function (values) {
        _this.props.editAllItem(_this.props.id, values);
      });

      return _this;
    }

    _createClass(ElementWrapper, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        var _this$props3 = this.props,
            removeItem = _this$props3.removeItem,
            id = _this$props3.id,
            type = _this$props3.type,
            dragHandleProps = _this$props3.dragHandleProps,
            placeholder = _this$props3.placeholder,
            simpleView = _this$props3.simpleView,
            item = _this$props3.item,
            components = _this$props3.components,
            onCancel = _this$props3.onCancel;

        var _find = (0, _ramda.find)((0, _ramda.propEq)('type', type), components),
            staticContent = _find.staticContent,
            ableCorrect = _find.ableCorrect,
            renderInfo = _find.renderInfo,
            name = _find.name,
            icon = _find.icon;

        return _react["default"].createElement("div", {
          className: (0, _classnames["default"])(styles.sortableRowWrapper, 'sortable-row-wrapper')
        }, _react["default"].createElement("div", {
          className: (0, _classnames["default"])(styles.sortableRow, 'sortable-row')
        }, _react["default"].createElement(_EditModalContext["default"].Consumer, null, function (_ref) {
          var setOpened = _ref.setOpened;
          return _react["default"].createElement("button", {
            type: "button",
            className: (0, _classnames["default"])(styles.toolbarEditBtn, 'toolbar-edit-btn'),
            onClick: function onClick() {
              return setOpened(id);
            }
          }, _react["default"].createElement("i", {
            className: "fa fa-edit"
          }));
        }), _react["default"].createElement("button", {
          type: "button",
          className: (0, _classnames["default"])(styles.toolbarRemoveBtn, 'toolbar-remove-btn'),
          onClick: function onClick() {
            return removeItem(id);
          }
        }, _react["default"].createElement("i", {
          className: "fa fa-remove"
        })), _react["default"].createElement("div", _extends({}, dragHandleProps, {
          className: (0, _classnames["default"])(styles.sortableRowDragHandle, 'sortable-row-drag-handle')
        }), _react["default"].createElement("i", {
          className: "fa fa-reorder"
        })), _react["default"].createElement("div", {
          className: (0, _classnames["default"])(styles.sortableRowContent, 'sortable-row-content')
        }, simpleView ? _react["default"].createElement("div", null, _react["default"].createElement("div", null, renderInfo && _react["default"].createElement("div", {
          className: (0, _classnames["default"])(styles.sortableRowInfo, 'sortable-row-info')
        }, renderInfo(item))), _react["default"].createElement("div", {
          className: (0, _classnames["default"])(styles.sortableRowContentInfo, 'sortable-row-content-info')
        }, _react["default"].createElement("i", {
          className: "fa fa-".concat(icon)
        }), name)) : staticContent ? this.renderComponent(staticContent, ableCorrect) : _react["default"].createElement(_antd.Form.Item, {
          label: this.renderLabel(),
          colon: false
        }, this.renderComponent(staticContent, ableCorrect)))), _react["default"].createElement(_EditModalContext["default"].Consumer, null, function (_ref2) {
          var opened = _ref2.opened,
              setOpened = _ref2.setOpened;
          return _react["default"].createElement(_antd.Modal, {
            className: (0, _classnames["default"])(editorStyles.editorModal, 'react-form-builder-element-modal'),
            title: name,
            visible: id === opened,
            onCancel: function onCancel() {
              return setOpened(null);
            },
            style: {
              minWidth: 1000
            },
            destroyOnClose: true,
            footer: null
          }, _react["default"].createElement(_EditElement["default"], {
            item: item,
            placeholder: placeholder,
            onCancel: function onCancel() {
              return setOpened(null);
            },
            onSubmit: function onSubmit(values) {
              _this2.onSubmit(values);

              setOpened(null);
            }
          }));
        }));
      }
    }]);

    return ElementWrapper;
  }(_react.Component);

  _defineProperty(ElementWrapper, "propTypes", {
    removeItem: _propTypes["default"].func,
    editItem: _propTypes["default"].func,
    id: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
    simpleView: _propTypes["default"].bool
  });

  _defineProperty(ElementWrapper, "defaultProps", {
    simpleView: true
  });

  return (0, _withComponentsContext["default"])(ElementWrapper);
};

exports.withElementWrapper = withElementWrapper;